Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ 7a07475f

History | View | Annotate | Download (48.8 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 6e3bf290 Michael Hanselmann
SHELL_ENV_INIT = autotools/shell-env-init
35 e8230860 Michael Hanselmann
36 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
37 22c5390d Iustin Pop
# the directory + 'dir' suffix
38 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
39 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
40 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
41 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
42 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
43 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
44 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
45 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
46 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
47 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
48 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
49 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
50 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
51 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
52 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
53 e8230860 Michael Hanselmann
54 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
55 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
56 a4f12da4 Michael Hanselmann
57 d5506465 Iustin Pop
HTOOLS_DIRS = \
58 d5506465 Iustin Pop
	htools \
59 d5506465 Iustin Pop
	htools/Ganeti \
60 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
61 458a286a Iustin Pop
	htools/Ganeti/HTools \
62 4cbe9bda Iustin Pop
	htools/Ganeti/HTools/Program \
63 f0f3a6df Iustin Pop
	htools/Ganeti/Query \
64 e5a29b6c Iustin Pop
	htest \
65 e5a29b6c Iustin Pop
	htest/Test \
66 2733df51 Iustin Pop
	htest/Test/Ganeti \
67 aed2325f Iustin Pop
	htest/Test/Ganeti/Confd \
68 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools \
69 aed2325f Iustin Pop
	htest/Test/Ganeti/Query
70 d5506465 Iustin Pop
71 e8230860 Michael Hanselmann
DIRS = \
72 dad26941 Iustin Pop
	$(HTOOLS_DIRS) \
73 e8230860 Michael Hanselmann
	autotools \
74 e8230860 Michael Hanselmann
	daemons \
75 e8230860 Michael Hanselmann
	devel \
76 e8230860 Michael Hanselmann
	doc \
77 e8230860 Michael Hanselmann
	doc/examples \
78 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
79 dad26941 Iustin Pop
	doc/examples/hooks \
80 dad26941 Iustin Pop
	htest/data \
81 dad26941 Iustin Pop
	htest/data/rapi \
82 dad26941 Iustin Pop
	htest/shelltests \
83 e8230860 Michael Hanselmann
	lib \
84 f9897b6d Michael Hanselmann
	lib/build \
85 dad26941 Iustin Pop
	lib/client \
86 2f16ea8f Michael Hanselmann
	lib/confd \
87 ff9efc03 Michael Hanselmann
	lib/http \
88 e8230860 Michael Hanselmann
	lib/hypervisor \
89 bb44b1ae Michael Hanselmann
	lib/impexpd \
90 dc101ecc Michael Hanselmann
	lib/masterd \
91 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
92 899c4d2c Michael Hanselmann
	lib/server \
93 0d2bf835 René Nussbaumer
	lib/tools \
94 c047a981 Michael Hanselmann
	lib/utils \
95 9f4bb951 Michael Hanselmann
	lib/watcher \
96 e8230860 Michael Hanselmann
	man \
97 e8230860 Michael Hanselmann
	qa \
98 e8230860 Michael Hanselmann
	test \
99 e8230860 Michael Hanselmann
	test/data \
100 1e6fab60 Agata Murawska
	test/data/ovfdata \
101 d92518d3 Agata Murawska
	test/data/ovfdata/other \
102 e8230860 Michael Hanselmann
	tools
103 e8230860 Michael Hanselmann
104 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
105 c964d962 Michael Hanselmann
	scripts \
106 22c5390d Iustin Pop
	$(APIDOC_DIR) \
107 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
108 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
109 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
110 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
111 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
112 662de722 Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Query \
113 dad26941 Iustin Pop
	$(APIDOC_PY_DIR) \
114 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
115 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
116 dad26941 Iustin Pop
	$(COVERAGE_PY_DIR) \
117 b91e9518 Iustin Pop
	.hpc
118 2750b299 Michael Hanselmann
119 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
120 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
121 6b997854 Michael Hanselmann
	doc/html
122 6b997854 Michael Hanselmann
123 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
124 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
125 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
126 6b997854 Michael Hanselmann
	doc/html/_*
127 6b997854 Michael Hanselmann
128 22c5390d Iustin Pop
# some helper vars
129 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
130 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
131 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
132 22c5390d Iustin Pop
APIDOC_DIR = doc/api
133 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
134 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
135 22c5390d Iustin Pop
136 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
137 d17e74b4 Iustin Pop
	$(docpng) \
138 b76aac08 Michael Hanselmann
	$(maninput) \
139 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
140 84a12e40 Iustin Pop
	doc/news.rst \
141 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
142 84a12e40 Iustin Pop
	vcs-version
143 2ab2b9f5 Iustin Pop
144 d17e74b4 Iustin Pop
maintainer-clean-local:
145 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
146 d17e74b4 Iustin Pop
147 e8230860 Michael Hanselmann
CLEANFILES = \
148 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
149 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
150 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
151 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
152 f774bd03 Michael Hanselmann
	epydoc.conf \
153 5098afd1 Iustin Pop
	$(REPLACE_VARS_SED) \
154 6e3bf290 Michael Hanselmann
	$(SHELL_ENV_INIT) \
155 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
156 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
157 e8230860 Michael Hanselmann
	devel/upload \
158 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
159 f72f8622 Iustin Pop
	doc/examples/bash_completion \
160 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
161 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
162 2ab2b9f5 Iustin Pop
	$(man_MANS) \
163 2ab2b9f5 Iustin Pop
	$(manhtml) \
164 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
165 e5afb848 Michael Hanselmann
	tools/vcluster-setup \
166 3735787e Iustin Pop
	stamp-directories \
167 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
168 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
169 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
170 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
171 b0dcdc10 Iustin Pop
	htools/ganeti-confd \
172 f0f3a6df Iustin Pop
	.hpc/*.mix htools/*.tix htest/*.tix \
173 191ff68c Iustin Pop
	doc/hs-lint.html
174 e8230860 Michael Hanselmann
175 4c3d5fb6 Iustin Pop
GENERATED_FILES = \
176 5098afd1 Iustin Pop
	$(built_base_sources) \
177 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
178 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
179 96a7481d Michael Hanselmann
180 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES =
181 ada0e680 Iustin Pop
if WANT_HTOOLS
182 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES += $(HS_PROGS)
183 04520998 Iustin Pop
if ENABLE_CONFD
184 f8d01158 Iustin Pop
HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
185 ada0e680 Iustin Pop
endif
186 ada0e680 Iustin Pop
endif
187 ada0e680 Iustin Pop
188 96a7481d Michael Hanselmann
built_base_sources = \
189 3735787e Iustin Pop
	stamp-directories \
190 3735787e Iustin Pop
	stamp-srclinks
191 2d1f248e Michael Hanselmann
192 96a7481d Michael Hanselmann
built_python_base_sources = \
193 13aeae6a Iustin Pop
	lib/_autoconf.py \
194 96a7481d Michael Hanselmann
	lib/_vcsversion.py
195 96a7481d Michael Hanselmann
196 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
197 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
198 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
199 e8230860 Michael Hanselmann
200 5098afd1 Iustin Pop
# Generating the RPC wrappers depends on many things, so make sure
201 5098afd1 Iustin Pop
# it's built at the end of the built sources
202 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
203 96a7481d Michael Hanselmann
204 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
205 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
206 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
207 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
208 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
209 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
210 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
211 656a7fdf Iustin Pop
212 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
213 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
214 08366664 Michael Hanselmann
215 f9897b6d Michael Hanselmann
noinst_PYTHON = \
216 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
217 dad26941 Iustin Pop
	lib/build/shell_example_lexer.py \
218 dad26941 Iustin Pop
	lib/build/sphinx_ext.py
219 f9897b6d Michael Hanselmann
220 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
221 e8230860 Michael Hanselmann
	lib/__init__.py \
222 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
223 e8230860 Michael Hanselmann
	lib/backend.py \
224 e8230860 Michael Hanselmann
	lib/bdev.py \
225 e8230860 Michael Hanselmann
	lib/bootstrap.py \
226 e8230860 Michael Hanselmann
	lib/cli.py \
227 e8230860 Michael Hanselmann
	lib/cmdlib.py \
228 cea881e5 Michael Hanselmann
	lib/compat.py \
229 e8230860 Michael Hanselmann
	lib/config.py \
230 e8230860 Michael Hanselmann
	lib/constants.py \
231 821d9e43 Michael Hanselmann
	lib/daemon.py \
232 e8230860 Michael Hanselmann
	lib/errors.py \
233 62e0e880 Iustin Pop
	lib/ht.py \
234 e8230860 Michael Hanselmann
	lib/jqueue.py \
235 8b537bb0 Michael Hanselmann
	lib/jstore.py \
236 e8230860 Michael Hanselmann
	lib/locking.py \
237 e8230860 Michael Hanselmann
	lib/luxi.py \
238 e8230860 Michael Hanselmann
	lib/mcpu.py \
239 a744b676 Manuel Franceschini
	lib/netutils.py \
240 e8230860 Michael Hanselmann
	lib/objects.py \
241 32683096 René Nussbaumer
	lib/objectutils.py \
242 e8230860 Michael Hanselmann
	lib/opcodes.py \
243 ced78a66 Agata Murawska
	lib/ovf.py \
244 3329f4de Michael Hanselmann
	lib/pathutils.py \
245 a123dc19 Michael Hanselmann
	lib/qlang.py \
246 4ca96421 Michael Hanselmann
	lib/query.py \
247 e8230860 Michael Hanselmann
	lib/rpc.py \
248 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
249 f12e1736 René Nussbaumer
	lib/runtime.py \
250 e8230860 Michael Hanselmann
	lib/serializer.py \
251 e8230860 Michael Hanselmann
	lib/ssconf.py \
252 e8230860 Michael Hanselmann
	lib/ssh.py \
253 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
254 1338f2b4 Balazs Lecz
	lib/uidpool.py \
255 05e733b4 Michael Hanselmann
	lib/vcluster.py \
256 76094e37 Michael Hanselmann
	lib/workerpool.py
257 e8230860 Michael Hanselmann
258 2d48a3a2 Michael Hanselmann
client_PYTHON = \
259 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
260 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
261 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
262 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
263 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
264 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
265 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
266 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
267 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
268 2d48a3a2 Michael Hanselmann
269 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
270 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
271 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
272 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
273 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
274 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
275 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
276 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
277 e8230860 Michael Hanselmann
278 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
279 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
280 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
281 95ab4de9 David Knowles
	lib/rapi/client.py \
282 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
283 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
284 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
285 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
286 8c229cc7 Oleksiy Mishchenko
287 ff9efc03 Michael Hanselmann
http_PYTHON = \
288 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
289 be500c29 Michael Hanselmann
	lib/http/auth.py \
290 02cab3e7 Michael Hanselmann
	lib/http/client.py \
291 02cab3e7 Michael Hanselmann
	lib/http/server.py
292 ff9efc03 Michael Hanselmann
293 12426ae1 Guido Trotter
confd_PYTHON = \
294 71f27d19 Guido Trotter
	lib/confd/__init__.py \
295 b0dcdc10 Iustin Pop
	lib/confd/client.py
296 8c229cc7 Oleksiy Mishchenko
297 dc101ecc Michael Hanselmann
masterd_PYTHON = \
298 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
299 0fcd0cad René Nussbaumer
	lib/masterd/iallocator.py \
300 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
301 dc101ecc Michael Hanselmann
302 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
303 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
304 bb44b1ae Michael Hanselmann
305 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
306 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
307 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
308 adf6301e Michael Hanselmann
	lib/watcher/state.py
309 9f4bb951 Michael Hanselmann
310 899c4d2c Michael Hanselmann
server_PYTHON = \
311 29d91329 Michael Hanselmann
	lib/server/__init__.py \
312 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
313 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
314 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
315 899c4d2c Michael Hanselmann
316 0d2bf835 René Nussbaumer
pytools_PYTHON = \
317 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
318 d12b9f66 Michael Hanselmann
	lib/tools/ensure_dirs.py \
319 d12b9f66 Michael Hanselmann
	lib/tools/prepare_node_join.py
320 0d2bf835 René Nussbaumer
321 c047a981 Michael Hanselmann
utils_PYTHON = \
322 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
323 79d22269 Michael Hanselmann
	lib/utils/algo.py \
324 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
325 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
326 3865ca48 Michael Hanselmann
	lib/utils/io.py \
327 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
328 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
329 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
330 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
331 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
332 7831fc5f Michael Hanselmann
	lib/utils/text.py \
333 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
334 c50645c0 Michael Hanselmann
	lib/utils/x509.py
335 c047a981 Michael Hanselmann
336 f05c99f3 Michael Hanselmann
docrst = \
337 ffa6869f Iustin Pop
	doc/admin.rst \
338 dad26941 Iustin Pop
	doc/cluster-merge.rst \
339 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
340 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
341 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
342 1eb85930 Guido Trotter
	doc/design-2.3.rst \
343 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
344 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
345 40309ed7 Michael Hanselmann
	doc/design-2.6.rst \
346 97aac894 Michael Hanselmann
	doc/design-2.7.rst \
347 dad26941 Iustin Pop
	doc/design-autorepair.rst \
348 dad26941 Iustin Pop
	doc/design-bulk-create.rst \
349 dad26941 Iustin Pop
	doc/design-chained-jobs.rst \
350 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
351 dad26941 Iustin Pop
	doc/design-draft.rst \
352 dad26941 Iustin Pop
	doc/design-htools-2.3.rst \
353 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
354 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
355 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
356 d55b80b0 Guido Trotter
	doc/design-linuxha.rst \
357 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
358 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
359 dad26941 Iustin Pop
	doc/design-node-state-cache.rst \
360 dad26941 Iustin Pop
	doc/design-oob.rst \
361 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
362 dad26941 Iustin Pop
	doc/design-partitioned.rst \
363 dad26941 Iustin Pop
	doc/design-query-splitting.rst \
364 dad26941 Iustin Pop
	doc/design-query2.rst \
365 2ff01d78 Michael Hanselmann
	doc/design-remote-commands.rst \
366 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
367 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
368 f98efa98 Michael Hanselmann
	doc/design-ssh-setup.rst \
369 109e07c2 Guido Trotter
	doc/design-monitoring-agent.rst \
370 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
371 dad26941 Iustin Pop
	doc/design-x509-ca.rst \
372 62947ebb Michael Hanselmann
	doc/devnotes.rst \
373 e2078d28 Iustin Pop
	doc/glossary.rst \
374 4d6443f4 Iustin Pop
	doc/hooks.rst \
375 876860a3 Iustin Pop
	doc/iallocator.rst \
376 d17e74b4 Iustin Pop
	doc/index.rst \
377 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
378 28e15341 Iustin Pop
	doc/install.rst \
379 9725b53d Michael Hanselmann
	doc/locking.rst \
380 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
381 c71a1a3d Iustin Pop
	doc/news.rst \
382 a47dc554 René Nussbaumer
	doc/ovfconverter.rst \
383 6d81475c Iustin Pop
	doc/rapi.rst \
384 b76aac08 Michael Hanselmann
	doc/security.rst \
385 35dd762d Michael Hanselmann
	doc/upgrade.rst \
386 ab171697 Michael Hanselmann
	doc/virtual-cluster.rst \
387 c71a1a3d Iustin Pop
	doc/walkthrough.rst
388 f05c99f3 Michael Hanselmann
389 0985325d Iustin Pop
HS_PROGS = htools/htools
390 22e513e7 Agata Murawska
HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
391 ada0e680 Iustin Pop
HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
392 d6159933 Iustin Pop
393 19e21a6c Iustin Pop
HS_ALL_PROGS = \
394 19e21a6c Iustin Pop
	$(HS_PROGS) \
395 19e21a6c Iustin Pop
	htest/hpc-htools \
396 19e21a6c Iustin Pop
	htest/test \
397 19e21a6c Iustin Pop
	htools/hconfd \
398 19e21a6c Iustin Pop
	htools/rpc-test
399 19e21a6c Iustin Pop
400 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
401 189b51fa Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
402 3096524e Iustin Pop
403 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
404 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
405 d6159933 Iustin Pop
HEXTRA =
406 f0f3a6df Iustin Pop
# internal extra flags (used for htest/test mainly)
407 c7ec3025 Iustin Pop
HEXTRA_INT =
408 b91e9518 Iustin Pop
# exclude options for coverage reports
409 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
410 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
411 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
412 dad26941 Iustin Pop
	--exclude Ganeti.THH \
413 2997cb0a Iustin Pop
	--exclude Ganeti.Version \
414 2733df51 Iustin Pop
	--exclude Test.Ganeti.TestCommon \
415 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHTools \
416 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHelper \
417 b88fcdd0 Iustin Pop
	--exclude Test.Ganeti.TestImports \
418 51309138 Iustin Pop
	$(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
419 d6159933 Iustin Pop
420 c3f67183 Iustin Pop
HS_LIB_SRCS = \
421 dad26941 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
422 dad26941 Iustin Pop
	htools/Ganeti/Common.hs \
423 dad26941 Iustin Pop
	htools/Ganeti/Compat.hs \
424 dad26941 Iustin Pop
	htools/Ganeti/Confd.hs \
425 dad26941 Iustin Pop
	htools/Ganeti/Confd/Server.hs \
426 dad26941 Iustin Pop
	htools/Ganeti/Confd/Utils.hs \
427 dad26941 Iustin Pop
	htools/Ganeti/Config.hs \
428 dad26941 Iustin Pop
	htools/Ganeti/Daemon.hs \
429 ef3ad027 Iustin Pop
	htools/Ganeti/Errors.hs \
430 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
431 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
432 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
433 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
434 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
435 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
436 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
437 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
438 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
439 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
440 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
441 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
442 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
443 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
444 22e513e7 Agata Murawska
	htools/Ganeti/HTools/Program/Hcheck.hs \
445 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
446 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
447 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
448 dad26941 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
449 dad26941 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
450 dad26941 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
451 dad26941 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
452 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
453 f3baf5ef Iustin Pop
	htools/Ganeti/JSON.hs \
454 dad26941 Iustin Pop
	htools/Ganeti/Jobs.hs \
455 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
456 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
457 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
458 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
459 9eeb0aa5 Michael Hanselmann
	htools/Ganeti/Path.hs \
460 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Common.hs \
461 8a65c02b Iustin Pop
	htools/Ganeti/Query/Filter.hs \
462 40246fa0 Agata Murawska
	htools/Ganeti/Query/Group.hs \
463 4cab6703 Iustin Pop
	htools/Ganeti/Query/Language.hs \
464 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Node.hs \
465 4cbe9bda Iustin Pop
	htools/Ganeti/Query/Query.hs \
466 4cab6703 Iustin Pop
	htools/Ganeti/Query/Server.hs \
467 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Types.hs \
468 4cab6703 Iustin Pop
	htools/Ganeti/Rpc.hs \
469 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
470 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
471 26d62e4c Iustin Pop
	htools/Ganeti/THH.hs \
472 26d62e4c Iustin Pop
	htools/Ganeti/Utils.hs
473 51309138 Iustin Pop
474 51309138 Iustin Pop
HS_TEST_SRCS = \
475 1493a93b Iustin Pop
	htest/Test/Ganeti/BasicTypes.hs \
476 51000365 Iustin Pop
	htest/Test/Ganeti/Common.hs \
477 305e174c Iustin Pop
	htest/Test/Ganeti/Confd/Utils.hs \
478 dad26941 Iustin Pop
	htest/Test/Ganeti/Daemon.hs \
479 ef3ad027 Iustin Pop
	htest/Test/Ganeti/Errors.hs \
480 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/CLI.hs \
481 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Cluster.hs \
482 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Container.hs \
483 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Instance.hs \
484 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Loader.hs \
485 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Node.hs \
486 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/PeerMap.hs \
487 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Simu.hs \
488 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Text.hs \
489 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Types.hs \
490 2d87bd0a Iustin Pop
	htest/Test/Ganeti/JSON.hs \
491 2d87bd0a Iustin Pop
	htest/Test/Ganeti/Jobs.hs \
492 aed2325f Iustin Pop
	htest/Test/Ganeti/Luxi.hs \
493 2733df51 Iustin Pop
	htest/Test/Ganeti/Objects.hs \
494 aed2325f Iustin Pop
	htest/Test/Ganeti/OpCodes.hs \
495 90171729 Iustin Pop
	htest/Test/Ganeti/Query/Filter.hs \
496 aed2325f Iustin Pop
	htest/Test/Ganeti/Query/Language.hs \
497 b9bdc10e Iustin Pop
	htest/Test/Ganeti/Query/Query.hs \
498 aed2325f Iustin Pop
	htest/Test/Ganeti/Rpc.hs \
499 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/Ssconf.hs \
500 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestCommon.hs \
501 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestHTools.hs \
502 26d62e4c Iustin Pop
	htest/Test/Ganeti/TestHelper.hs \
503 26d62e4c Iustin Pop
	htest/Test/Ganeti/Utils.hs
504 e4cc4c11 Iustin Pop
505 51309138 Iustin Pop
HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
506 d6159933 Iustin Pop
507 b88fcdd0 Iustin Pop
HS_BUILT_SRCS = \
508 b88fcdd0 Iustin Pop
	htest/Test/Ganeti/TestImports.hs \
509 b88fcdd0 Iustin Pop
	htools/Ganeti/Constants.hs \
510 2997cb0a Iustin Pop
	htools/Ganeti/Version.hs
511 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
512 d6159933 Iustin Pop
513 3735787e Iustin Pop
$(RUN_IN_TEMPDIR): | stamp-directories
514 c964d962 Michael Hanselmann
515 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
516 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
517 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
518 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
519 a2d917f3 Iustin Pop
# it changes
520 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
521 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
522 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
523 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
524 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
525 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
526 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
527 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
528 13de7d59 Michael Hanselmann
	    -d . \
529 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
530 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
531 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
532 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
533 13de7d59 Michael Hanselmann
	touch $@
534 13de7d59 Michael Hanselmann
535 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
536 2ab2b9f5 Iustin Pop
537 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
538 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
539 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
540 b76aac08 Michael Hanselmann
541 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
542 cbf3d64b Michael Hanselmann
	set -e; \
543 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
544 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
545 cbf3d64b Michael Hanselmann
	  echo; \
546 cbf3d64b Michael Hanselmann
	  cat $<; \
547 cbf3d64b Michael Hanselmann
	} > $@
548 cbf3d64b Michael Hanselmann
549 b8195800 Iustin Pop
docdot = \
550 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
551 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
552 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
553 b8195800 Iustin Pop
554 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
555 e8230860 Michael Hanselmann
556 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
557 7e1ccbe0 Michael Hanselmann
# distributed)
558 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
559 7e1ccbe0 Michael Hanselmann
	devel/upload \
560 7e1ccbe0 Michael Hanselmann
	doc/html \
561 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
562 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
563 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
564 7e1ccbe0 Michael Hanselmann
	$(manhtml)
565 f29266b4 Iustin Pop
566 4f3d5b76 Michael Hanselmann
gnt_scripts = \
567 e8230860 Michael Hanselmann
	scripts/gnt-backup \
568 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
569 e8230860 Michael Hanselmann
	scripts/gnt-debug \
570 667dbd6b Adeodato Simo
	scripts/gnt-group \
571 e8230860 Michael Hanselmann
	scripts/gnt-instance \
572 e8230860 Michael Hanselmann
	scripts/gnt-job \
573 e8230860 Michael Hanselmann
	scripts/gnt-node \
574 e8230860 Michael Hanselmann
	scripts/gnt-os
575 e8230860 Michael Hanselmann
576 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
577 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
578 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
579 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
580 dad26941 Iustin Pop
	daemons/ganeti-watcher \
581 656a7fdf Iustin Pop
	$(gnt_scripts)
582 2d48a3a2 Michael Hanselmann
583 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
584 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
585 d12b9f66 Michael Hanselmann
	tools/ensure-dirs \
586 d12b9f66 Michael Hanselmann
	tools/prepare-node-join
587 0d2bf835 René Nussbaumer
588 a8c68e44 Michael Hanselmann
qa_scripts = \
589 a0c3e726 Michael Hanselmann
	qa/__init__.py \
590 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
591 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
592 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
593 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
594 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
595 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
596 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
597 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
598 09470dd8 Michael Hanselmann
	qa/qa_job.py \
599 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
600 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
601 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
602 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
603 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
604 a8c68e44 Michael Hanselmann
605 d6159933 Iustin Pop
bin_SCRIPTS =
606 d6159933 Iustin Pop
if WANT_HTOOLS
607 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
608 458a286a Iustin Pop
install-exec-hook:
609 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
610 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
611 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
612 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
613 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
614 7fa52acd Iustin Pop
		$(LN_S) -f htools \
615 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
616 201b6c34 Iustin Pop
	done
617 d6159933 Iustin Pop
endif
618 d6159933 Iustin Pop
619 51309138 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
620 21a5e56c Iustin Pop
	@if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
621 21a5e56c Iustin Pop
	  echo "Error: cannot run unittests without the development" \
622 21a5e56c Iustin Pop
	       " libraries (see devnotes.rst)" 1>&2; \
623 fd0bc853 Iustin Pop
	  exit 1; \
624 49e11c49 Iustin Pop
	fi
625 f0f3a6df Iustin Pop
	@rm -f $(notdir $@).tix
626 f0f3a6df Iustin Pop
	$(GHC) --make \
627 ef958f2a Iustin Pop
	  $(HFLAGS) \
628 21a5e56c Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
629 f0f3a6df Iustin Pop
	  -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
630 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
631 70b6c284 Iustin Pop
	@touch "$@"
632 70b6c284 Iustin Pop
633 f0f3a6df Iustin Pop
# for the htest/test binary, we need to enable profiling/coverage
634 f0f3a6df Iustin Pop
htest/test: HEXTRA_INT=-fhpc -ihtest
635 b91e9518 Iustin Pop
636 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
637 f0f3a6df Iustin Pop
htest/hpc-htools: HEXTRA_INT=-fhpc
638 25cdf177 Iustin Pop
639 04d15e63 Iustin Pop
# test dependency
640 f0f3a6df Iustin Pop
htest/offline-tests.sh: htest/hpc-htools
641 04d15e63 Iustin Pop
642 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
643 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
644 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
645 c7ec3025 Iustin Pop
# run before)
646 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
647 c7ec3025 Iustin Pop
hs-prof:
648 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) clean
649 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
650 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
651 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
652 c7ec3025 Iustin Pop
653 c7ec3025 Iustin Pop
hs-prof-quick:
654 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
655 c7ec3025 Iustin Pop
656 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
657 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
658 4f3d5b76 Michael Hanselmann
659 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
660 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
661 46118ed2 Iustin Pop
	daemons/ganeti-cleaner
662 fc3fd894 Michael Hanselmann
663 04520998 Iustin Pop
if ENABLE_CONFD
664 b0dcdc10 Iustin Pop
htools/ganeti-confd: htools/hconfd
665 b0dcdc10 Iustin Pop
	cp -f $< $@
666 b0dcdc10 Iustin Pop
667 b0dcdc10 Iustin Pop
nodist_sbin_SCRIPTS += htools/ganeti-confd
668 73b0fa69 Iustin Pop
endif
669 73b0fa69 Iustin Pop
670 cc120286 Bernardo Dal Seno
python_scripts = \
671 e8230860 Michael Hanselmann
	tools/burnin \
672 e8230860 Michael Hanselmann
	tools/cfgshell \
673 e8230860 Michael Hanselmann
	tools/cfgupgrade \
674 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
675 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
676 4ef0399b Iustin Pop
	tools/confd-client \
677 d62cbd3a Michael Hanselmann
	tools/fmtjson \
678 ea5fd476 Iustin Pop
	tools/lvmstrap \
679 6bf273d5 Michael Hanselmann
	tools/move-instance \
680 ced78a66 Agata Murawska
	tools/ovfconverter \
681 dad26941 Iustin Pop
	tools/sanitize-config \
682 dad26941 Iustin Pop
	tools/setup-ssh
683 e8230860 Michael Hanselmann
684 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
685 cc120286 Bernardo Dal Seno
	$(python_scripts) \
686 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
687 dad26941 Iustin Pop
	tools/master-ip-setup \
688 dad26941 Iustin Pop
	tools/xm-console-wrapper
689 61631293 Stephen Shirley
690 29386d3e Michael Hanselmann
nodist_tools_SCRIPTS = \
691 29386d3e Michael Hanselmann
	tools/vcluster-setup
692 29386d3e Michael Hanselmann
693 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
694 c6ccba7e Michael Hanselmann
	daemons/import-export \
695 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
696 2d76b580 Michael Hanselmann
697 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
698 d12b9f66 Michael Hanselmann
	tools/ensure-dirs \
699 d12b9f66 Michael Hanselmann
	tools/prepare-node-join
700 0d2bf835 René Nussbaumer
701 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
702 2d76b580 Michael Hanselmann
	daemons/daemon-util \
703 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
704 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
705 f154a7a3 Michael Hanselmann
706 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
707 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
708 0d2bf835 René Nussbaumer
709 e8230860 Michael Hanselmann
EXTRA_DIST = \
710 e8230860 Michael Hanselmann
	NEWS \
711 7a03d293 Michael Hanselmann
	UPGRADE \
712 f774bd03 Michael Hanselmann
	epydoc.conf.in \
713 70c771f6 Michael Hanselmann
	pylintrc \
714 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
715 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
716 5d3c30df Michael Hanselmann
	autotools/check-header \
717 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
718 c55cc346 Iustin Pop
	autotools/check-man-dashes \
719 73d0e218 Iustin Pop
	autotools/check-man-warnings \
720 c81ed2b2 Michael Hanselmann
	autotools/check-news \
721 dad26941 Iustin Pop
	autotools/check-python-code \
722 e627fe09 Michael Hanselmann
	autotools/check-tar \
723 96602be4 Michael Hanselmann
	autotools/check-version \
724 d99d1e36 Iustin Pop
	autotools/convert-constants \
725 95eb4188 Michael Hanselmann
	autotools/docpp \
726 27e336af Michael Hanselmann
	autotools/gen-coverage \
727 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
728 387863a5 Iustin Pop
	autotools/wrong-hardcoded-paths \
729 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
730 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
731 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
732 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
733 e8230860 Michael Hanselmann
	devel/upload.in \
734 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
735 29386d3e Michael Hanselmann
	tools/vcluster-setup.in \
736 b8195800 Iustin Pop
	$(docdot) \
737 f727d134 Michael Hanselmann
	$(docpng) \
738 d17e74b4 Iustin Pop
	$(docrst) \
739 d17e74b4 Iustin Pop
	doc/conf.py \
740 d17e74b4 Iustin Pop
	doc/html \
741 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
742 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
743 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
744 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
745 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
746 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
747 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
748 e4d452b4 Michael Hanselmann
	test/lockperf.py \
749 e8230860 Michael Hanselmann
	test/testutils.py \
750 e8230860 Michael Hanselmann
	test/mocks.py \
751 e8230860 Michael Hanselmann
	$(dist_TESTS) \
752 e8230860 Michael Hanselmann
	$(TEST_FILES) \
753 6be8e2bf Iustin Pop
	man/footer.rst \
754 6be8e2bf Iustin Pop
	$(manrst) \
755 f727d134 Michael Hanselmann
	$(maninput) \
756 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
757 d6159933 Iustin Pop
	$(qa_scripts) \
758 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
759 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
760 04d15e63 Iustin Pop
	htools/lint-hints.hs \
761 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
762 7a07475f Iustin Pop
	htest/offline-test.sh \
763 7a07475f Iustin Pop
	.ghci
764 e8230860 Michael Hanselmann
765 e8230860 Michael Hanselmann
man_MANS = \
766 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
767 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
768 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
769 320d986d Iustin Pop
	man/ganeti-masterd.8 \
770 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
771 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
772 320d986d Iustin Pop
	man/ganeti-rapi.8 \
773 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
774 dad26941 Iustin Pop
	man/ganeti.7 \
775 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
776 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
777 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
778 667dbd6b Adeodato Simo
	man/gnt-group.8 \
779 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
780 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
781 e8230860 Michael Hanselmann
	man/gnt-node.8 \
782 5a19bd35 Iustin Pop
	man/gnt-os.8 \
783 5a19bd35 Iustin Pop
	man/hail.1 \
784 5a19bd35 Iustin Pop
	man/hbal.1 \
785 f18e4168 Iustin Pop
	man/hcheck.1 \
786 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
787 5a19bd35 Iustin Pop
	man/hscan.1 \
788 d26d808a Iustin Pop
	man/hspace.1 \
789 d26d808a Iustin Pop
	man/htools.1
790 e8230860 Michael Hanselmann
791 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
792 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
793 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
794 25c92bc5 Michael Hanselmann
maninput = \
795 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
796 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
797 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
798 e8230860 Michael Hanselmann
799 e8230860 Michael Hanselmann
TEST_FILES = \
800 dad26941 Iustin Pop
	htest/data/common-suffix.data \
801 dad26941 Iustin Pop
	htest/data/hail-alloc-drbd.json \
802 dad26941 Iustin Pop
	htest/data/hail-change-group.json \
803 dad26941 Iustin Pop
	htest/data/hail-invalid-reloc.json \
804 dad26941 Iustin Pop
	htest/data/hail-node-evac.json \
805 dad26941 Iustin Pop
	htest/data/hail-reloc-drbd.json \
806 659d769d Dato Simó
	htest/data/hbal-excl-tags.data \
807 dad26941 Iustin Pop
	htest/data/hbal-split-insts.data \
808 dad26941 Iustin Pop
	htest/data/invalid-node.data \
809 dad26941 Iustin Pop
	htest/data/missing-resources.data \
810 dad26941 Iustin Pop
	htest/data/rapi/groups.json \
811 dad26941 Iustin Pop
	htest/data/rapi/info.json \
812 dad26941 Iustin Pop
	htest/data/rapi/instances.json \
813 dad26941 Iustin Pop
	htest/data/rapi/nodes.json \
814 dad26941 Iustin Pop
	htest/shelltests/htools-balancing.test \
815 dad26941 Iustin Pop
	htest/shelltests/htools-basic.test \
816 dad26941 Iustin Pop
	htest/shelltests/htools-dynutil.test \
817 dad26941 Iustin Pop
	htest/shelltests/htools-excl.test \
818 dad26941 Iustin Pop
	htest/shelltests/htools-hail.test \
819 dad26941 Iustin Pop
	htest/shelltests/htools-hspace.test \
820 dad26941 Iustin Pop
	htest/shelltests/htools-invalid.test \
821 dad26941 Iustin Pop
	htest/shelltests/htools-multi-group.test \
822 dad26941 Iustin Pop
	htest/shelltests/htools-no-backend.test \
823 dad26941 Iustin Pop
	htest/shelltests/htools-rapi.test \
824 dad26941 Iustin Pop
	htest/shelltests/htools-single-group.test \
825 dad26941 Iustin Pop
	htest/shelltests/htools-text-backend.test \
826 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
827 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
828 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
829 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
830 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
831 27e46076 Michael Hanselmann
	test/data/cert1.pem \
832 d12b9f66 Michael Hanselmann
	test/data/cert2.pem \
833 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
834 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
835 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
836 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
837 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
838 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
839 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
840 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
841 dad26941 Iustin Pop
	test/data/kvm_0.15.90_help.txt \
842 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
843 dad26941 Iustin Pop
	test/data/kvm_1.0_help.txt \
844 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
845 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
846 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
847 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
848 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
849 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
850 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
851 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
852 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
853 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
854 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
855 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
856 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
857 dad26941 Iustin Pop
	test/data/ovfdata/other/rawdisk.raw \
858 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
859 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
860 dad26941 Iustin Pop
	test/data/ovfdata/second_disk.vmdk \
861 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
862 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
863 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
864 dad26941 Iustin Pop
	test/data/ovfdata/wrong_extension.ovd \
865 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
866 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
867 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
868 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
869 dad26941 Iustin Pop
	test/data/proc_drbd8.txt \
870 dad26941 Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
871 dad26941 Iustin Pop
	test/data/proc_drbd83.txt \
872 dad26941 Iustin Pop
	test/data/proc_drbd83_sync.txt \
873 dad26941 Iustin Pop
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
874 dad26941 Iustin Pop
	test/data/sys_drbd_usermode_helper.txt \
875 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
876 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
877 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
878 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
879 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
880 30f2802f Iustin Pop
	test/ganeti-cli.test \
881 dad26941 Iustin Pop
	test/gnt-cli.test \
882 dad26941 Iustin Pop
	test/import-export_unittest-helper
883 e8230860 Michael Hanselmann
884 e8c8cf1a Michael Hanselmann
python_tests = \
885 3ade0e0e Michael Hanselmann
	doc/examples/rapi_testutils.py \
886 dad26941 Iustin Pop
	test/cfgupgrade_unittest.py \
887 dad26941 Iustin Pop
	test/docs_unittest.py \
888 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
889 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
890 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
891 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
892 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
893 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
894 e1c701e7 Michael Hanselmann
	test/ganeti.client.gnt_job_unittest.py \
895 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
896 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
897 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
898 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
899 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
900 dad26941 Iustin Pop
	test/ganeti.daemon_unittest.py \
901 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
902 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
903 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
904 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
905 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
906 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
907 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
908 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
909 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
910 dad26941 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
911 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
912 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
913 6f1aa78d Michael Hanselmann
	test/ganeti.jstore_unittest.py \
914 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
915 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
916 33b4fa9f René Nussbaumer
	test/ganeti.masterd.iallocator_unittest.py \
917 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
918 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
919 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
920 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
921 32683096 René Nussbaumer
	test/ganeti.objectutils_unittest.py \
922 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
923 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
924 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
925 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
926 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
927 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
928 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
929 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
930 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
931 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
932 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
933 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
934 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
935 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
936 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
937 d12b9f66 Michael Hanselmann
	test/ganeti.tools.prepare_node_join_unittest.py \
938 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
939 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
940 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
941 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
942 7ebadeb3 Bernardo Dal Seno
	test/ganeti.utils.io_unittest-runasroot.py \
943 dad26941 Iustin Pop
	test/ganeti.utils.io_unittest.py \
944 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
945 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
946 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
947 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
948 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
949 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
950 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
951 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
952 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
953 05e733b4 Michael Hanselmann
	test/ganeti.vcluster_unittest.py \
954 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
955 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
956 dad26941 Iustin Pop
	test/qa.qa_config_unittest.py \
957 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
958 e8230860 Michael Hanselmann
959 f0f3a6df Iustin Pop
haskell_tests = htest/test
960 b91e9518 Iustin Pop
961 e8c8cf1a Michael Hanselmann
dist_TESTS = \
962 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
963 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
964 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
965 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
966 30f2802f Iustin Pop
	test/cli-test.bash \
967 92886204 Michael Hanselmann
	test/bash_completion.bash \
968 e8c8cf1a Michael Hanselmann
	$(python_tests)
969 e8c8cf1a Michael Hanselmann
970 e8230860 Michael Hanselmann
nodist_TESTS =
971 d3cd5a3f Iustin Pop
check_SCRIPTS =
972 d3cd5a3f Iustin Pop
973 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
974 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
975 f0f3a6df Iustin Pop
dist_TESTS += htest/offline-test.sh
976 f0f3a6df Iustin Pop
check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
977 b91e9518 Iustin Pop
endif
978 e8230860 Michael Hanselmann
979 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
980 e8230860 Michael Hanselmann
981 27e336af Michael Hanselmann
# Environment for all tests
982 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
983 30f2802f Iustin Pop
	PYTHONPATH=. \
984 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
985 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
986 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
987 27e336af Michael Hanselmann
988 27e336af Michael Hanselmann
# Environment for tests run by automake
989 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
990 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
991 6e06b36c Iustin Pop
992 eed5c5df Michael Hanselmann
all_python_code = \
993 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
994 cc120286 Bernardo Dal Seno
	$(python_scripts) \
995 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
996 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
997 e8c8cf1a Michael Hanselmann
	$(python_tests) \
998 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
999 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
1000 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
1001 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
1002 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
1003 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
1004 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
1005 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
1006 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
1007 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
1008 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
1009 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
1010 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
1011 a8c68e44 Michael Hanselmann
	$(qa_scripts)
1012 01a3a718 Michael Hanselmann
1013 eed5c5df Michael Hanselmann
srclink_files = \
1014 6be8e2bf Iustin Pop
	man/footer.rst \
1015 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
1016 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
1017 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
1018 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
1019 30f2802f Iustin Pop
	test/cli-test.bash \
1020 92886204 Michael Hanselmann
	test/bash_completion.bash \
1021 f0f3a6df Iustin Pop
	htest/offline-test.sh \
1022 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
1023 d6159933 Iustin Pop
	$(all_python_code) \
1024 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1025 eed5c5df Michael Hanselmann
1026 eed5c5df Michael Hanselmann
check_python_code = \
1027 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1028 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1029 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1030 95eb4188 Michael Hanselmann
	$(DOCPP) \
1031 eed5c5df Michael Hanselmann
	$(all_python_code)
1032 eed5c5df Michael Hanselmann
1033 e4e7c7df Michael Hanselmann
lint_python_code = \
1034 f60d352e Michael Hanselmann
	ganeti \
1035 f1763373 Iustin Pop
	ganeti/http/server.py \
1036 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
1037 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1038 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
1039 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1040 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1041 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1042 95eb4188 Michael Hanselmann
	$(DOCPP) \
1043 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
1044 eed5c5df Michael Hanselmann
1045 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
1046 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
1047 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
1048 f6cbcc06 Michael Hanselmann
1049 21bf2e2e Andrea Spadaccini
pep8_python_code = \
1050 21bf2e2e Andrea Spadaccini
	ganeti \
1051 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
1052 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
1053 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1054 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
1055 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
1056 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1057 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
1058 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
1059 21bf2e2e Andrea Spadaccini
	qa
1060 21bf2e2e Andrea Spadaccini
1061 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
1062 571b34f8 Michael Hanselmann
1063 46118ed2 Iustin Pop
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1064 7172f605 Michael Hanselmann
1065 92886204 Michael Hanselmann
test/bash_completion.bash: doc/examples/bash_completion-debug
1066 92886204 Michael Hanselmann
1067 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1068 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
1069 26916aad Apollon Oikonomopoulos
	chmod +x $@
1070 26916aad Apollon Oikonomopoulos
1071 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1072 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1073 e8230860 Michael Hanselmann
	chmod u+x $@
1074 e8230860 Michael Hanselmann
1075 29386d3e Michael Hanselmann
tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1076 29386d3e Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1077 29386d3e Michael Hanselmann
	chmod +x $@
1078 29386d3e Michael Hanselmann
1079 490bec02 Iustin Pop
daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1080 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1081 5c566e17 Michael Hanselmann
	chmod +x $@
1082 e8230860 Michael Hanselmann
1083 490bec02 Iustin Pop
doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1084 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1085 e8230860 Michael Hanselmann
1086 e80aeb89 Michael Hanselmann
doc/examples/bash_completion: BC_ARGS = --compact
1087 e80aeb89 Michael Hanselmann
doc/examples/bash_completion-debug: BC_ARGS =
1088 e80aeb89 Michael Hanselmann
1089 e80aeb89 Michael Hanselmann
doc/examples/bash_completion doc/examples/bash_completion-debug: \
1090 e80aeb89 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1091 4c3d5fb6 Iustin Pop
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1092 46118ed2 Iustin Pop
	daemons/ganeti-cleaner \
1093 ada0e680 Iustin Pop
	$(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1094 e80aeb89 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1095 e80aeb89 Michael Hanselmann
	  $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1096 4f3d5b76 Michael Hanselmann
1097 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
1098 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1099 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
1100 f86e82ef Iustin Pop
1101 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
1102 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
1103 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1104 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
1105 de8eea3e Iustin Pop
1106 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
1107 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1108 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1109 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
1110 6be8e2bf Iustin Pop
1111 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1112 d7772efa Iustin Pop
	lib/build/shell_example_lexer.py \
1113 a13d6911 Iustin Pop
	| $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1114 387863a5 Iustin Pop
	@echo "Checking $< for hardcoded paths..."
1115 387863a5 Iustin Pop
	@if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1116 387863a5 Iustin Pop
	  echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1117 387863a5 Iustin Pop
	  exit 1; \
1118 387863a5 Iustin Pop
	fi
1119 a13d6911 Iustin Pop
	set -e ; \
1120 a13d6911 Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1121 a13d6911 Iustin Pop
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1122 a13d6911 Iustin Pop
	trap - EXIT
1123 fcdb582d Michael Hanselmann
1124 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1125 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1126 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1127 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1128 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1129 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1130 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1131 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1132 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1133 9c45babb Iustin Pop
	trap - EXIT
1134 9c45babb Iustin Pop
1135 2ab2b9f5 Iustin Pop
1136 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1137 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1138 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1139 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1140 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1141 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1142 6be8e2bf Iustin Pop
1143 55398706 Iustin Pop
man/%: man/%.in  $(REPLACE_VARS_SED)
1144 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1145 f29266b4 Iustin Pop
1146 fc1282b8 Iustin Pop
epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1147 fc1282b8 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1148 f774bd03 Michael Hanselmann
1149 84a12e40 Iustin Pop
vcs-version:
1150 84a12e40 Iustin Pop
	if test -d .git; then \
1151 84a12e40 Iustin Pop
	  git describe > $@; \
1152 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1153 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1154 84a12e40 Iustin Pop
	fi
1155 84a12e40 Iustin Pop
1156 316dc1ff Iustin Pop
.PHONY: clean-vcs-version
1157 316dc1ff Iustin Pop
clean-vcs-version:
1158 316dc1ff Iustin Pop
	rm -f vcs-version
1159 316dc1ff Iustin Pop
1160 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1161 84a12e40 Iustin Pop
regen-vcs-version:
1162 e8230860 Michael Hanselmann
	set -e; \
1163 84a12e40 Iustin Pop
	cd $(srcdir); \
1164 84a12e40 Iustin Pop
	if test -d .git; then \
1165 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1166 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1167 84a12e40 Iustin Pop
	fi
1168 84a12e40 Iustin Pop
1169 2997cb0a Iustin Pop
htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1170 4c3d5fb6 Iustin Pop
	vcs-version $(built_base_sources)
1171 d6159933 Iustin Pop
	set -e; \
1172 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1173 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1174 d6159933 Iustin Pop
1175 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1176 f11e524b Iustin Pop
	lib/constants.py lib/_autoconf.py lib/luxi.py \
1177 4c3d5fb6 Iustin Pop
	$(CONVERT_CONSTANTS) $(built_base_sources) \
1178 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1179 11fd5a86 Iustin Pop
	set -e; \
1180 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1181 d99d1e36 Iustin Pop
1182 b88fcdd0 Iustin Pop
htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1183 b88fcdd0 Iustin Pop
	$(built_base_sources)
1184 b88fcdd0 Iustin Pop
	set -e; \
1185 b88fcdd0 Iustin Pop
	{ cat $< ; \
1186 b88fcdd0 Iustin Pop
	  echo ; \
1187 b88fcdd0 Iustin Pop
	  for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1188 b88fcdd0 Iustin Pop
	    echo "import $$name ()" ; \
1189 b88fcdd0 Iustin Pop
	  done ; \
1190 b88fcdd0 Iustin Pop
	} > $@
1191 b88fcdd0 Iustin Pop
1192 3735787e Iustin Pop
lib/_autoconf.py: Makefile | stamp-directories
1193 84a12e40 Iustin Pop
	set -e; \
1194 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1195 e8230860 Michael Hanselmann
	  echo '#'; \
1196 67047322 Iustin Pop
	  echo ''; \
1197 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1198 67047322 Iustin Pop
	  echo '';\
1199 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1200 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1201 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1202 67047322 Iustin Pop
	  echo ''; \
1203 67047322 Iustin Pop
	  echo '"""'; \
1204 67047322 Iustin Pop
	  echo ''; \
1205 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1206 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1207 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1208 0a4e7f24 Iustin Pop
	  echo ''; \
1209 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1210 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1211 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1212 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1213 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1214 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1215 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1216 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1217 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1218 052783ff Michael Hanselmann
	  echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1219 052783ff Michael Hanselmann
	  echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1220 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1221 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1222 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1223 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1224 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1225 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1226 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1227 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1228 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1229 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1230 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1231 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1232 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1233 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1234 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1235 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1236 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1237 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1238 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1239 ada0e680 Iustin Pop
	  echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1240 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1241 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1242 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1243 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1244 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1245 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1246 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1247 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1248 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1249 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1250 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1251 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1252 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1253 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1254 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1255 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1256 21a5e56c Iustin Pop
	  echo "HTOOLS = True"; \
1257 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1258 1eb37421 René Nussbaumer
	  echo "XEN_CMD = '$(XEN_CMD)'"; \
1259 42ab9ac4 Iustin Pop
	  echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1260 e8230860 Michael Hanselmann
	} > $@
1261 e8230860 Michael Hanselmann
1262 3735787e Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1263 13aeae6a Iustin Pop
	set -e; \
1264 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1265 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1266 13aeae6a Iustin Pop
	  echo '#'; \
1267 13aeae6a Iustin Pop
	  echo ''; \
1268 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1269 13aeae6a Iustin Pop
	  echo '';\
1270 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1271 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1272 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1273 13aeae6a Iustin Pop
	  echo ''; \
1274 13aeae6a Iustin Pop
	  echo '"""'; \
1275 13aeae6a Iustin Pop
	  echo ''; \
1276 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1277 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1278 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1279 13aeae6a Iustin Pop
	  echo ''; \
1280 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1281 13aeae6a Iustin Pop
	} > $@
1282 13aeae6a Iustin Pop
1283 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1284 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1285 d5a2a550 Michael Hanselmann
1286 6e3bf290 Michael Hanselmann
$(SHELL_ENV_INIT): Makefile stamp-directories
1287 6e3bf290 Michael Hanselmann
	set -e; \
1288 6e3bf290 Michael Hanselmann
	{ echo '# Allow overriding for tests'; \
1289 6e3bf290 Michael Hanselmann
	  echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1290 6e3bf290 Michael Hanselmann
	  echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1291 6e3bf290 Michael Hanselmann
	  echo; \
1292 6e3bf290 Michael Hanselmann
	  echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1293 6e3bf290 Michael Hanselmann
	  echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1294 6e3bf290 Michael Hanselmann
	  echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1295 6e3bf290 Michael Hanselmann
	  echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1296 6e3bf290 Michael Hanselmann
	  echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1297 6e3bf290 Michael Hanselmann
	} > $@
1298 6e3bf290 Michael Hanselmann
1299 6e3bf290 Michael Hanselmann
$(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1300 e8230860 Michael Hanselmann
	set -e; \
1301 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1302 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1303 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1304 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1305 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1306 335ba60d Guido Trotter
	  echo 's#@LIBDIR@#$(libdir)#g'; \
1307 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1308 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1309 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1310 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1311 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1312 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1313 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1314 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1315 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1316 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1317 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1318 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1319 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1320 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1321 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1322 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1323 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1324 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1325 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1326 fc1282b8 Iustin Pop
	  echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1327 42ab9ac4 Iustin Pop
	  echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1328 6e3bf290 Michael Hanselmann
	  echo; \
1329 6e3bf290 Michael Hanselmann
	  echo '/^@SHELL_ENV_INIT@$$/ {'; \
1330 6e3bf290 Michael Hanselmann
	  echo '  r $(SHELL_ENV_INIT)'; \
1331 6e3bf290 Michael Hanselmann
	  echo '  d'; \
1332 6e3bf290 Michael Hanselmann
	  echo '}'; \
1333 e8230860 Michael Hanselmann
	} > $@
1334 e8230860 Michael Hanselmann
1335 67313146 Michael Hanselmann
# Using deferred evaluation
1336 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1337 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1338 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1339 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1340 d12b9f66 Michael Hanselmann
tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1341 189b51fa Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1342 67313146 Michael Hanselmann
1343 3735787e Iustin Pop
$(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1344 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1345 2d48a3a2 Michael Hanselmann
	set -e; \
1346 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1347 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1348 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1349 2d48a3a2 Michael Hanselmann
	  echo; \
1350 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1351 2d48a3a2 Michael Hanselmann
	  echo; \
1352 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1353 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1354 2d48a3a2 Michael Hanselmann
	  echo; \
1355 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1356 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1357 2d48a3a2 Michael Hanselmann
	  echo; \
1358 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1359 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1360 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1361 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1362 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1363 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1364 2d48a3a2 Michael Hanselmann
	  echo; \
1365 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1366 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1367 2d48a3a2 Michael Hanselmann
	} > $@
1368 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1369 2d48a3a2 Michael Hanselmann
1370 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1371 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1372 3096524e Iustin Pop
	set -e; \
1373 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1374 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1375 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1376 3096524e Iustin Pop
	  echo; \
1377 f0f3a6df Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1378 3096524e Iustin Pop
	} > $@
1379 3096524e Iustin Pop
	chmod u+x $@
1380 3096524e Iustin Pop
1381 3735787e Iustin Pop
stamp-directories: Makefile
1382 924ecd85 Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) ganeti
1383 3735787e Iustin Pop
	@mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1384 3735787e Iustin Pop
	touch $@
1385 3735787e Iustin Pop
1386 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1387 e8230860 Michael Hanselmann
# files when building.
1388 3735787e Iustin Pop
stamp-srclinks: Makefile | stamp-directories
1389 e8230860 Michael Hanselmann
	set -e; \
1390 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1391 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1392 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1393 e8230860 Michael Hanselmann
		fi; \
1394 e8230860 Michael Hanselmann
	done
1395 dd1dfd9a Michael Hanselmann
	touch $@
1396 97a37b3f Michael Hanselmann
1397 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1398 9ff7e35c Michael Hanselmann
ganeti:
1399 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1400 9ff7e35c Michael Hanselmann
1401 6b997854 Michael Hanselmann
.PHONY: check-dirs
1402 4c3d5fb6 Iustin Pop
check-dirs: $(GENERATED_FILES)
1403 0c1103d6 Iustin Pop
	@set -e; \
1404 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1405 6b997854 Michael Hanselmann
		-name .git -o \
1406 6b997854 Michael Hanselmann
		-name autom4te.cache \
1407 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1408 6b997854 Michael Hanselmann
		error=; \
1409 6b997854 Michael Hanselmann
		while read dir; do \
1410 6b997854 Michael Hanselmann
			case "$$dir" in \
1411 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1412 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1413 6b997854 Michael Hanselmann
			esac; \
1414 6b997854 Michael Hanselmann
		done; \
1415 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1416 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1417 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1418 6b997854 Michael Hanselmann
				error=1; \
1419 6b997854 Michael Hanselmann
			fi \
1420 6b997854 Michael Hanselmann
		done; \
1421 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1422 6b997854 Michael Hanselmann
	}
1423 6b997854 Michael Hanselmann
1424 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1425 4c3d5fb6 Iustin Pop
check-local: check-dirs $(GENERATED_FILES)
1426 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1427 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1428 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1429 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1430 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1431 dad26941 Iustin Pop
	@expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1432 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1433 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1434 9488fd1d Michael Hanselmann
		exit 1; \
1435 7ecb3d0e Michael Hanselmann
	fi; \
1436 04c998a5 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1437 04c998a5 Michael Hanselmann
			doc/security.rst; do \
1438 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1439 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1440 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1441 d5114fa1 Michael Hanselmann
			exit 1; \
1442 d5114fa1 Michael Hanselmann
		fi; \
1443 7a962ecc Michael Hanselmann
	done; \
1444 fc07a14e Michael Hanselmann
	if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1445 fc07a14e Michael Hanselmann
		echo "File $(top_srcdir)/doc/design-$$expver.rst not found"; \
1446 7a962ecc Michael Hanselmann
		exit 1; \
1447 7a962ecc Michael Hanselmann
	fi
1448 eed5c5df Michael Hanselmann
1449 49e11c49 Iustin Pop
.PHONY: hs-check
1450 f0f3a6df Iustin Pop
hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1451 49e11c49 Iustin Pop
	@rm -f test.tix
1452 f0f3a6df Iustin Pop
	./htest/test
1453 f0f3a6df Iustin Pop
	HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1454 49e11c49 Iustin Pop
1455 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1456 5ae4945a Iustin Pop
# E121: continuation line indentation is not a multiple of four
1457 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1458 5ae4945a Iustin Pop
# E125: continuation line does not distinguish itself from next logical line
1459 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1460 5ae4945a Iustin Pop
# E127: continuation line over-indented for visual indent
1461 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1462 5ae4945a Iustin Pop
# note: do NOT add E128 here; it's a valid style error in most cases!
1463 5ae4945a Iustin Pop
# I've seen real errors, but also some cases were we indent wrongly
1464 5ae4945a Iustin Pop
# due to line length; try to rework the cases where it is triggered,
1465 5ae4945a Iustin Pop
# instead of silencing it
1466 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1467 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1468 5ae4945a Iustin Pop
PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1469 08366664 Michael Hanselmann
1470 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1471 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1472 08366664 Michael Hanselmann
1473 6e4c8f68 Iustin Pop
LINT_TARGETS = pylint pylint-qa
1474 6e4c8f68 Iustin Pop
if HAS_PEP8
1475 6e4c8f68 Iustin Pop
LINT_TARGETS += pep8
1476 6e4c8f68 Iustin Pop
endif
1477 6e4c8f68 Iustin Pop
if HAS_HLINT
1478 6e4c8f68 Iustin Pop
LINT_TARGETS += hlint
1479 6e4c8f68 Iustin Pop
endif
1480 6e4c8f68 Iustin Pop
1481 e0098923 Iustin Pop
.PHONY: lint
1482 6e4c8f68 Iustin Pop
lint: $(LINT_TARGETS)
1483 6e4c8f68 Iustin Pop
1484 6e4c8f68 Iustin Pop
.PHONY: pylint
1485 4c3d5fb6 Iustin Pop
pylint: $(GENERATED_FILES)
1486 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1487 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1488 6e4c8f68 Iustin Pop
1489 6e4c8f68 Iustin Pop
.PHONY: pylint-qa
1490 4c3d5fb6 Iustin Pop
pylint-qa: $(GENERATED_FILES)
1491 6e4c8f68 Iustin Pop
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1492 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1493 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1494 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1495 e0098923 Iustin Pop
1496 6e4c8f68 Iustin Pop
.PHONY: pep8
1497 4c3d5fb6 Iustin Pop
pep8: $(GENERATED_FILES)
1498 6e4c8f68 Iustin Pop
	@test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1499 6e4c8f68 Iustin Pop
	$(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1500 6e4c8f68 Iustin Pop
		--repeat $(pep8_python_code)
1501 6e4c8f68 Iustin Pop
1502 2cdaf225 Iustin Pop
# FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1503 191ff68c Iustin Pop
.PHONY: hlint
1504 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1505 6e4c8f68 Iustin Pop
	@test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1506 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1507 6e4c8f68 Iustin Pop
	$(HLINT) --report=doc/hs-lint.html --cross $$C \
1508 3603605a Iustin Pop
	  --ignore "Use first" \
1509 3603605a Iustin Pop
	  --ignore "Use comparing" \
1510 3603605a Iustin Pop
	  --ignore "Use on" \
1511 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1512 2cdaf225 Iustin Pop
	  --ignore "Use &&&" \
1513 2cdaf225 Iustin Pop
	  --ignore "Use void" \
1514 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1515 4ab40ed5 Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1516 191ff68c Iustin Pop
1517 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1518 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1519 84a12e40 Iustin Pop
dist-hook:
1520 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1521 316dc1ff Iustin Pop
	rm -f $(top_distdir)/vcs-version
1522 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1523 84a12e40 Iustin Pop
1524 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1525 b6f2e47f Iustin Pop
distcheck-hook:
1526 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1527 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1528 c6aa0c42 Michael Hanselmann
		exit 1; \
1529 c6aa0c42 Michael Hanselmann
	fi
1530 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1531 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1532 c6aa0c42 Michael Hanselmann
		exit 1; \
1533 c6aa0c42 Michael Hanselmann
	fi
1534 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1535 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1536 b6f2e47f Iustin Pop
		exit 1; \
1537 b6f2e47f Iustin Pop
	fi
1538 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1539 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1540 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1541 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1542 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1543 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1544 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1545 bf0b21da Michael Hanselmann
		exit 1; \
1546 bf0b21da Michael Hanselmann
	fi
1547 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1548 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1549 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1550 c7b86f6c Michael Hanselmann
		exit 1; \
1551 c7b86f6c Michael Hanselmann
	fi
1552 c7b86f6c Michael Hanselmann
1553 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1554 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1555 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1556 b6f2e47f Iustin Pop
1557 7213dded René Nussbaumer
distrebuildcheck: dist
1558 7213dded René Nussbaumer
	set -e; \
1559 7213dded René Nussbaumer
	builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1560 7213dded René Nussbaumer
	trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1561 7213dded René Nussbaumer
	cd $$builddir; \
1562 7213dded René Nussbaumer
	tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1563 7213dded René Nussbaumer
	cd $(distdir); \
1564 7213dded René Nussbaumer
	./configure; \
1565 7213dded René Nussbaumer
	$(MAKE) maintainer-clean; \
1566 7213dded René Nussbaumer
	cp $(abs_srcdir)/vcs-version .; \
1567 7213dded René Nussbaumer
	./configure; \
1568 7213dded René Nussbaumer
	$(MAKE) $(AM_MAKEFLAGS)
1569 7213dded René Nussbaumer
1570 e627fe09 Michael Hanselmann
dist-release: dist
1571 e627fe09 Michael Hanselmann
	set -e; \
1572 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1573 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1574 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1575 e627fe09 Michael Hanselmann
		echo OK; \
1576 e627fe09 Michael Hanselmann
	done
1577 e627fe09 Michael Hanselmann
1578 8925faaa Iustin Pop
install-exec-local:
1579 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1580 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1581 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1582 e8230860 Michael Hanselmann
1583 d128fdb6 Iustin Pop
.PHONY: apidoc
1584 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1585 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1586 a38bfce5 Iustin Pop
else
1587 a38bfce5 Iustin Pop
apidoc: py-apidoc
1588 a38bfce5 Iustin Pop
endif
1589 a38bfce5 Iustin Pop
1590 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1591 4c3d5fb6 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1592 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1593 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1594 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1595 a38bfce5 Iustin Pop
1596 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1597 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1598 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1599 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1600 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1601 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1602 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1603 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1604 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1605 4cbe9bda Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1606 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1607 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1608 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1609 a38bfce5 Iustin Pop
	set -e ; \
1610 a38bfce5 Iustin Pop
	cd htools; \
1611 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1612 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1613 c478f837 Iustin Pop
	else OPTGHC=""; \
1614 c478f837 Iustin Pop
	fi; \
1615 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1616 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1617 1adec4be Iustin Pop
	fi; \
1618 21a5e56c Iustin Pop
	if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1619 21a5e56c Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1620 21a5e56c Iustin Pop
	fi; \
1621 b88fcdd0 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1622 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1623 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1624 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1625 a38bfce5 Iustin Pop
	done ; \
1626 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1627 18049dad Iustin Pop
		-t ganeti -p haddock-prologue \
1628 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1629 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1630 c478f837 Iustin Pop
		$$OPTGHC \
1631 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1632 d128fdb6 Iustin Pop
1633 13e720f1 Iustin Pop
.PHONY: TAGS
1634 4c3d5fb6 Iustin Pop
TAGS: $(GENERATED_FILES)
1635 13e720f1 Iustin Pop
	rm -f TAGS
1636 6b84f036 Iustin Pop
	$(GHC) -e ":etags" -v0 \
1637 6b84f036 Iustin Pop
	  $(filter-out -O -Werror,$(HFLAGS)) \
1638 21a5e56c Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1639 6b84f036 Iustin Pop
	  $(HS_LIBTEST_SRCS)
1640 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1641 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1642 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1643 2db53645 Iustin Pop
	  etags -l python -a -
1644 13e720f1 Iustin Pop
1645 27e336af Michael Hanselmann
.PHONY: coverage
1646 b91e9518 Iustin Pop
if WANT_HTOOLS
1647 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1648 b91e9518 Iustin Pop
else
1649 b91e9518 Iustin Pop
coverage: py-coverage
1650 b91e9518 Iustin Pop
endif
1651 b91e9518 Iustin Pop
1652 b91e9518 Iustin Pop
.PHONY: py-coverage
1653 4c3d5fb6 Iustin Pop
py-coverage: $(GENERATED_FILES) $(python_tests)
1654 141c8421 Michael Hanselmann
	@test -n "$(PYCOVERAGE)" || \
1655 141c8421 Michael Hanselmann
	    { echo 'python-coverage' not found during configure; exit 1; }
1656 27e336af Michael Hanselmann
	set -e; \
1657 141c8421 Michael Hanselmann
	COVERAGE=$(PYCOVERAGE) \
1658 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1659 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1660 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1661 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1662 e8c8cf1a Michael Hanselmann
	$(python_tests)
1663 27e336af Michael Hanselmann
1664 b91e9518 Iustin Pop
.PHONY: hs-coverage
1665 f0f3a6df Iustin Pop
hs-coverage: $(haskell_tests) htest/hpc-htools
1666 316dc1ff Iustin Pop
	rm -f *.tix
1667 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-check
1668 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1669 96eccc1f Iustin Pop
	hpc combine --union $(HPCEXCL) \
1670 96eccc1f Iustin Pop
	  test.tix hpc-htools.tix > coverage-htools.tix
1671 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1672 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1673 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1674 b91e9518 Iustin Pop
1675 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1676 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1677 ec8379bd Iustin Pop
.PHONY: live-test
1678 ec8379bd Iustin Pop
live-test: all
1679 ec8379bd Iustin Pop
	set -e ; \
1680 ec8379bd Iustin Pop
	cd htools; \
1681 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1682 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1683 ec8379bd Iustin Pop
	./live-test.sh; \
1684 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1685 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1686 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1687 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1688 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1689 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1690 b91e9518 Iustin Pop
1691 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1692 b341b9ca Guido Trotter
1693 6438e259 Iustin Pop
.PHONY: gitignore-check
1694 6438e259 Iustin Pop
gitignore-check:
1695 6438e259 Iustin Pop
	@if [ -n "`git status --short`" ]; then \
1696 6438e259 Iustin Pop
	  echo "Git status is not clean!" 1>&2 ; \
1697 6438e259 Iustin Pop
	  git status --short; \
1698 6438e259 Iustin Pop
	  exit 1; \
1699 6438e259 Iustin Pop
	fi
1700 6438e259 Iustin Pop
1701 37519c09 Iustin Pop
# Target that builds all binaries (including those that are not
1702 37519c09 Iustin Pop
# rebuilt except when running the tests)
1703 37519c09 Iustin Pop
.PHONY: really-all
1704 37519c09 Iustin Pop
really-all: all $(check_SCRIPTS) $(haskell_tests)
1705 37519c09 Iustin Pop
1706 1d45f7a0 Iustin Pop
# we don't need the ancient implicit rules:
1707 1d45f7a0 Iustin Pop
%: %,v
1708 1d45f7a0 Iustin Pop
%: RCS/%,v
1709 1d45f7a0 Iustin Pop
%: RCS/%
1710 1d45f7a0 Iustin Pop
%: s.%
1711 1d45f7a0 Iustin Pop
%: SCCS/s.%
1712 1d45f7a0 Iustin Pop
1713 3baa809c Michael Hanselmann
-include ./Makefile.local
1714 3baa809c Michael Hanselmann
1715 e8230860 Michael Hanselmann
# vim: set noet :